std::complex< _Tp > Class Template Reference
Numerics » Complex Numbers

## Public Types

typedef _Tp | value_type

## Public Member Functions

constexpr | complex (const _Tp &__r=_Tp(), const _Tp &__i=_Tp())
constexpr | complex (const complex &)=default
template<typename _Up >
constexpr | complex (const complex< _Up > &__z)
constexpr complex | __rep () const
constexpr _GLIBCXX_ABI_TAG_CXX11 _Tp | imag () const
constexpr void | imag (_Tp __val)
constexpr complex< _Tp > & | operator*= (const _Tp &)
template<typename _Up >
constexpr complex< _Tp > & | operator*= (const complex< _Up > &)
constexpr complex< _Tp > & | operator+= (const _Tp &__t)
template<typename _Up >
constexpr complex< _Tp > & | operator+= (const complex< _Up > &)
constexpr complex< _Tp > & | operator-= (const _Tp &__t)
template<typename _Up >
constexpr complex< _Tp > & | operator-= (const complex< _Up > &)
constexpr complex< _Tp > & | operator/= (const _Tp &)
template<typename _Up >
constexpr complex< _Tp > & | operator/= (const complex< _Up > &)
constexpr complex< _Tp > & | operator= (const _Tp &)
constexpr complex & | operator= (const complex &)=default
template<typename _Up >
constexpr complex< _Tp > & | operator= (const complex< _Up > &)
constexpr _GLIBCXX_ABI_TAG_CXX11 _Tp | real () const
constexpr void | real (_Tp __val)

## Detailed Description

### template<typename _Tp>
class std::complex< _Tp >

Template to represent complex numbers.

Specializations for float, double, and long double are part of the library. Results with any other type are not guaranteed.

Parameters

  Tp | Type of real and imaginary values.

Definition at line 127 of file complex.

## Member Typedef Documentation

## value_type

template<typename _Tp >

typedef _Tp std::complex< _Tp >::value_type

Value typedef.

Definition at line 131 of file complex.

## Constructor & Destructor Documentation

## complex() [1/2]

template<typename _Tp >

constexpr std::complex< _Tp >::complex | ( | const _Tp & | __r = `_Tp()`,
|  | const _Tp & | __i = `_Tp()`
| ) |  |

inline constexpr

Default constructor. First parameter is x, second parameter is y. Unspecified parameters default to 0.

Definition at line 135 of file complex.

## complex() [2/2]

template<typename _Tp >
template<typename _Up >

constexpr std::complex< _Tp >::complex | ( | const complex< _Up > & | __z | ) |

inline constexpr

Converting constructor.

Definition at line 145 of file complex.

## Member Function Documentation

## operator+=()

template<typename _Tp >

constexpr complex<_Tp>& std::complex< _Tp >::operator+= | ( | const _Tp & | __t | ) |

inline constexpr

Add a scalar to this complex number.

Definition at line 190 of file complex.

## operator-=()

template<typename _Tp >

constexpr complex<_Tp>& std::complex< _Tp >::operator-= | ( | const _Tp & | __t | ) |

inline constexpr

Subtract a scalar from this complex number.

Definition at line 199 of file complex.

The documentation for this class was generated from the following file:

- complex